\subsection{KMeans Enhancements}

\begin{frame}{KMeans Enhancements}

\begin{block}{\cite{Fahim2006}}

For each point, keep in memory the distance to the current nearest centroid

$\longrightarrow$ Avoid useless computations during next iteration

\textit{Easy to add in our implementation: keep distance in DPU} 

\end{block}

\vfill

\pause

\begin{block}{\cite{poteracs2014optimized}}

Define a border area made of points that can switch cluster

$\longrightarrow$ Reduce the number of distance computations

\textit{Harder to integrate: might involve the CPU} 

\end{block}

\end{frame}


\begin{frame}{KMeans Enhancements}

\begin{block}{$k$-means++ \cite{arthur2007k}}
Heuristic for the initial seed placement

$\longrightarrow$ Reduce computation time and improve quality of the result

\textit{Implementation quite straightforward} 

\end{block}

\vfill

\pause

\begin{block}{\cite{Kanungo:2002:EKC:628329.628801} }

More advanced data-structure for storing the points (\(kd\)-trees)

$\longrightarrow$ Reduce the number of distance computations

\textit{Implementation possible, but with big modifications}
\end{block}


\end{frame}